/**
 * Benchmark of serializer.
 */

import java.io.InputStream;
import java.io.OutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Date;

import NET.shudo.moba.io.ObjectWriter;
import NET.shudo.moba.io.ObjectReader;

class SerializeBenchmark {
  static final int ARRAY_SIZE = 1024 * 1024 / 8;	// 1MB
  //static final String NULL_FILE = "/dev/null";
  static final String NULL_FILE = "output";

  private void start(String[] argv) {
    double[] array = new double[ARRAY_SIZE];
    long stime = 0, etime = 0, dtime = 0;

    // initialize
    for (int i = 0; i < ARRAY_SIZE; i++) {
      double data = (double)(i % 256);
      array[i] = data;
    }

    // serialize
    try {
      OutputStream fout = new FileOutputStream(NULL_FILE);
      ObjectWriter sout = new ObjectWriter(fout);

      stime = (new Date()).getTime();

      sout.writeObject(array);

      etime = (new Date()).getTime();
    }
    catch (IOException e) {
      e.printStackTrace();  System.exit(1);
    }

    dtime = etime - stime;
    System.out.println(dtime  + " (msec)");
  }

  public static void main(String[] argv) {
    new SerializeBenchmark().start(argv);
  }
}
