/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.tools;

import java.io.*;
import NET.shudo.moba.io.ClassWriter;
import NET.shudo.moba.reflect.MetaClass;

class ClassDumper {
  static final String COMMAND = "java ClassDumper";

  private void start(String[] argv) {
    if (argv.length <= 0) {
      System.out.println("class name must be specified.");
      usage(COMMAND);  System.exit(1);
    }


    for (int i = 0; i < argv.length; i++) {
      // 饹˴ؤ
      Class clazz = null;
      MetaClass mc = null;
      try {
	clazz = Class.forName(argv[i]);
	mc = MetaClass.get(clazz);
	System.out.println("classfile length: " + mc.classfileLength());
      }
      catch (ClassNotFoundException e) {
	e.printStackTrace();  System.exit(1);
      }

      // ClassWriter 
      ClassWriter cout = null;
      String fName = argv[i] + ".classfile";
      try {
	cout = new ClassWriter(new FileOutputStream(fName));
      }
      catch (Exception e) {
	e.printStackTrace();  System.exit(1);
      }

      // 
      try {
	cout.writeClass(clazz);
	cout.close();
      }
      catch (IOException e) {
	e.printStackTrace();  System.exit(1);
      }

      System.out.println("classfile `" + fName + "' is generated.");
    }

    System.out.println("done.");
  }


  public static void usage(String cmd) {
    System.out.print("usage: ");
    System.out.print(cmd);
    System.out.println(" class_name ...");
  }

  public static void main(String[] argv) {
    new ClassDumper().start(argv);
  }
}
