/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.util;


import java.io.*;


/**
 * ThreadLister: JAVAåե pp.218-220
 */
public
class ThreadLister {
  // åɤ˴ؤɽ
  private static void print_thread_info(PrintStream out, Thread t,
					String indent) {
    if (t == null)  return;
    out.println(indent + "Thread: " + t.getName() +
		" Priority: " + t.getPriority() +
		(t.isDaemon() ? " Daemon" : "") +
		(t.isAlive() ? "" : " Not Alive"));
  }

  // åɥ롼פӤ˴ޤޤ륹åɡ롼׾ɽ
  private static void list_group(PrintStream out, ThreadGroup g,
				 String indent) {
    if (g == null)  return;

    int num_threads = g.activeCount();
    int num_groups = g.activeGroupCount();
    Thread[] threads = new Thread[num_threads];
    ThreadGroup[] groups = new ThreadGroup[num_groups];

    g.enumerate(threads, false);
    g.enumerate(groups, false);

    out.println(indent + "ThreadGroup: " + g.getName() +
		" Max Priority: " + g.getMaxPriority() +
		(g.isDaemon() ? " Daemon" : ""));

    for (int i = 0; i < num_threads; i++)
      print_thread_info(out, threads[i], indent + "  ");
    for (int i = 0; i < num_groups; i++)
      list_group(out, groups[i], indent + "  ");
  }

  // 롼ȤΥåɥ롼פõƵŪˤ겼ꥹȤ롣
  public static void listAllThreads(PrintStream out) {
    Thread current_thread = null;
    ThreadGroup current_thread_group = null;
    ThreadGroup root_thread_group = null;
    ThreadGroup parent = null;

    // ȤΥåɥ롼פ
    current_thread = Thread.currentThread();
    current_thread_group = current_thread.getThreadGroup();

    out.println("current thread: " + current_thread.getName());
    out.println();

    // ϡ롼ȤΥåɥ롼פõ˹Ԥ
    root_thread_group = current_thread_group;
    parent = root_thread_group.getParent();
    while (parent != null) {
      root_thread_group = parent;
      parent = parent.getParent();
    }

    // ơƵŪˤɽ
    list_group(out, root_thread_group, "");
  }

  // ᥤ᥽å
  public static void main(String[] args) {
    ThreadLister.listAllThreads(System.out);
  }
}
